"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _registry = _interopRequireDefault(require("./registry"));
var _exceptions = require("./exceptions");
var _ramda = require("ramda");
var _actions = require("./actions");
var _isSimpleComponent = _interopRequireDefault(require("./isSimpleComponent"));
var _persistence = require("./persistence");
var _ComponentErrorBoundary = _interopRequireDefault(require("./components/error/ComponentErrorBoundary.react"));
var _checkPropTypes = _interopRequireDefault(require("./checkPropTypes"));
var _dependencies = require("./actions/dependencies");
var _TreeContainer = require("./utils/TreeContainer");
var _APIController = require("./APIController.react");
var _reactRedux = require("react-redux");
var _excluded = ["_dash_error"];
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == typeof e || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var NOT_LOADING = {
  is_loading: false
};
function CheckedComponent(p) {
  var element = p.element,
    extraProps = p.extraProps,
    props = p.props,
    children = p.children,
    type = p.type;
  var errorMessage = (0, _checkPropTypes.default)(element.propTypes, props, 'component prop', element);
  if (errorMessage) {
    (0, _exceptions.propTypeErrorHandler)(errorMessage, props, type);
  }
  return createElement(element, props, extraProps, children);
}
CheckedComponent.propTypes = {
  children: _propTypes.default.any,
  element: _propTypes.default.any,
  layout: _propTypes.default.any,
  props: _propTypes.default.any,
  extraProps: _propTypes.default.any,
  id: _propTypes.default.string
};
function createElement(element, props, extraProps, children) {
  var allProps = (0, _ramda.mergeRight)(props, extraProps);
  if (Array.isArray(children)) {
    return /*#__PURE__*/_react.default.createElement.apply(_react.default, [element, allProps].concat(_toConsumableArray(children)));
  }
  return /*#__PURE__*/_react.default.createElement(element, allProps, children);
}
function isDryComponent(obj) {
  return (0, _ramda.type)(obj) === 'Object' && (0, _ramda.has)('type', obj) && (0, _ramda.has)('namespace', obj) && (0, _ramda.has)('props', obj);
}
var DashWrapper = function DashWrapper(props) {
  var context = (0, _react.useContext)(_APIController.DashContext);
  return /*#__PURE__*/_react.default.createElement(BaseTreeContainer, _extends({}, context.fn(), props, {
    _dashprivate_path: JSON.parse(props._dashprivate_path)
  }));
};
var TreeContainer = /*#__PURE__*/(0, _react.memo)(DashWrapper);
var BaseTreeContainer = /*#__PURE__*/function (_Component) {
  function BaseTreeContainer(props) {
    var _this;
    _classCallCheck(this, BaseTreeContainer);
    _this = _callSuper(this, BaseTreeContainer, [props]);
    _this.setProps = _this.setProps.bind(_this);
    return _this;
  }
  _inherits(BaseTreeContainer, _Component);
  return _createClass(BaseTreeContainer, [{
    key: "createContainer",
    value: function createContainer(props, component, path) {
      var key = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
      return (0, _isSimpleComponent.default)(component) ? component : /*#__PURE__*/_react.default.createElement(TreeContainer, {
        key: component && component.props && (0, _dependencies.stringifyId)(component.props.id) || key,
        _dashprivate_error: props._dashprivate_error,
        _dashprivate_layout: component,
        _dashprivate_loadingState: (0, _TreeContainer.getLoadingState)(component, path, props._dashprivate_loadingMap),
        _dashprivate_loadingStateHash: (0, _TreeContainer.getLoadingHash)(path, props._dashprivate_loadingMap),
        _dashprivate_path: JSON.stringify(path)
      });
    }
  }, {
    key: "setProps",
    value: function setProps(newProps) {
      var _this$props = this.props,
        _dashprivate_dispatch = _this$props._dashprivate_dispatch,
        _dashprivate_path = _this$props._dashprivate_path,
        _dashprivate_layout = _this$props._dashprivate_layout;
      var oldProps = this.getLayoutProps();
      var id = oldProps.id;
      var _dash_error = newProps._dash_error,
        rest = _objectWithoutProperties(newProps, _excluded);
      var changedProps = (0, _ramda.pickBy)(function (val, key) {
        return !(0, _ramda.equals)(val, oldProps[key]);
      }, rest);
      if (_dash_error) {
        _dashprivate_dispatch((0, _actions.onError)({
          type: 'frontEnd',
          error: _dash_error
        }));
      }
      if (!(0, _ramda.isEmpty)(changedProps)) {
        _dashprivate_dispatch(function (dispatch, getState) {
          var _getState = getState(),
            graphs = _getState.graphs;
          // Identify the modified props that are required for callbacks
          var watchedKeys = (0, _dependencies.getWatchedKeys)(id, (0, _ramda.keys)(changedProps), graphs);
          (0, _reactRedux.batch)(function () {
            // setProps here is triggered by the UI - record these changes
            // for persistence
            (0, _persistence.recordUiEdit)(_dashprivate_layout, newProps, dispatch);

            // Only dispatch changes to Dash if a watched prop changed
            if (watchedKeys.length) {
              dispatch((0, _actions.notifyObservers)({
                id,
                props: (0, _ramda.pick)(watchedKeys, changedProps)
              }));
            }

            // Always update this component's props
            dispatch((0, _actions.updateProps)({
              props: changedProps,
              itempath: _dashprivate_path
            }));
          });
        });
      }
    }
  }, {
    key: "getChildren",
    value: function getChildren(components, path) {
      var _this2 = this;
      if ((0, _ramda.isNil)(components)) {
        return null;
      }
      return Array.isArray(components) ? (0, _ramda.addIndex)(_ramda.map)(function (component, i) {
        return _this2.createContainer(_this2.props, component, (0, _ramda.concat)(path, ['props', 'children', i]));
      }, components) : this.createContainer(this.props, components, (0, _ramda.concat)(path, ['props', 'children']));
    }
  }, {
    key: "wrapChildrenProp",
    value: function wrapChildrenProp(node, childrenProp) {
      var _this3 = this;
      if (Array.isArray(node)) {
        return node.map(function (n, i) {
          return isDryComponent(n) ? _this3.createContainer(_this3.props, n, (0, _ramda.concat)(_this3.props._dashprivate_path, ['props'].concat(_toConsumableArray(childrenProp), [i])), i) : n;
        });
      }
      if (!isDryComponent(node)) {
        return node;
      }
      return this.createContainer(this.props, node, (0, _ramda.concat)(this.props._dashprivate_path, ['props'].concat(_toConsumableArray(childrenProp))));
    }
  }, {
    key: "getComponent",
    value: function getComponent(_dashprivate_layout, children, loading_state, setProps, _extraProps) {
      var _this4 = this;
      var _this$props2 = this.props,
        _dashprivate_config = _this$props2._dashprivate_config,
        _dashprivate_dispatch = _this$props2._dashprivate_dispatch,
        _dashprivate_error = _this$props2._dashprivate_error;
      if ((0, _ramda.isEmpty)(_dashprivate_layout)) {
        return null;
      }
      if ((0, _isSimpleComponent.default)(_dashprivate_layout)) {
        return _dashprivate_layout;
      }
      (0, _TreeContainer.validateComponent)(_dashprivate_layout);
      var element = _registry.default.resolve(_dashprivate_layout);

      // Hydrate components props
      var childrenProps = (0, _ramda.pathOr)([], ['children_props', _dashprivate_layout.namespace, _dashprivate_layout.type], _dashprivate_config);
      var props = (0, _ramda.mergeRight)((0, _ramda.dissoc)('children', _dashprivate_layout.props), _extraProps);
      var _loop = function _loop() {
          var childrenProp = childrenProps[i];
          var handleObject = function handleObject(obj, opath) {
            return (0, _ramda.mapObjIndexed)(function (node, k) {
              return _this4.wrapChildrenProp(node, [].concat(_toConsumableArray(opath), [k]));
            }, obj);
          };
          if (childrenProp.includes('.')) {
            var path = childrenProp.split('.');
            var node;
            var nodeValue;
            if (childrenProp.includes('[]')) {
              var frontPath = [],
                backPath = [],
                found = false,
                hasObject = false;
              path.forEach(function (p) {
                if (!found) {
                  if (p.includes('[]')) {
                    found = true;
                    if (p.includes('{}')) {
                      hasObject = true;
                      frontPath.push(p.replace('{}', '').replace('[]', ''));
                    } else {
                      frontPath.push(p.replace('[]', ''));
                    }
                  } else if (p.includes('{}')) {
                    hasObject = true;
                    frontPath.push(p.replace('{}', ''));
                  } else {
                    frontPath.push(p);
                  }
                } else {
                  if (p.includes('{}')) {
                    hasObject = true;
                    backPath.push(p.replace('{}', ''));
                  } else {
                    backPath.push(p);
                  }
                }
              });
              node = (0, _ramda.path)(frontPath, props);
              if (node === undefined || !node.length) {
                return 0; // continue
              }
              var firstNode = (0, _ramda.path)(backPath, node[0]);
              if (!firstNode) {
                return 0; // continue
              }
              nodeValue = node.map(function (element, i) {
                var elementPath = (0, _ramda.concat)(frontPath, (0, _ramda.concat)([i], backPath));
                var listValue;
                if (hasObject) {
                  if (backPath.length) {
                    listValue = handleObject((0, _ramda.path)(backPath, element), elementPath);
                  } else {
                    listValue = handleObject(element, elementPath);
                  }
                } else {
                  listValue = _this4.wrapChildrenProp((0, _ramda.path)(backPath, element), elementPath);
                }
                return (0, _ramda.assocPath)(backPath, listValue, element);
              });
              path = frontPath;
            } else {
              if (childrenProp.includes('{}')) {
                // Only supports one level of nesting.
                var front = [];
                var dynamic = [];
                var hasBack = false;
                var _backPath = [];
                for (var j = 0; j < path.length; j++) {
                  var cur = path[j];
                  if (cur.includes('{}')) {
                    dynamic = (0, _ramda.concat)(front, [cur.replace('{}', '')]);
                    if (j < path.length - 1) {
                      hasBack = true;
                    }
                  } else {
                    if (hasBack) {
                      _backPath.push(cur);
                    } else {
                      front.push(cur);
                    }
                  }
                }
                var dynValue = (0, _ramda.path)(dynamic, props);
                if (dynValue !== undefined) {
                  nodeValue = (0, _ramda.mapObjIndexed)(function (d, k) {
                    return _this4.wrapChildrenProp(hasBack ? (0, _ramda.path)(_backPath, d) : d, hasBack ? (0, _ramda.concat)(dynamic, (0, _ramda.concat)([k], _backPath)) : (0, _ramda.concat)(dynamic, [k]));
                  }, dynValue);
                  path = dynamic;
                }
              } else {
                node = (0, _ramda.path)(path, props);
                if (node === undefined) {
                  return 0; // continue
                }
                nodeValue = _this4.wrapChildrenProp(node, path);
              }
            }
            props = (0, _ramda.assocPath)(path, nodeValue, props);
          } else {
            if (childrenProp.includes('{}')) {
              var opath = childrenProp.replace('{}', '');
              var isArray = childrenProp.includes('[]');
              if (isArray) {
                opath = opath.replace('[]', '');
              }
              var _node = props[opath];
              if (_node !== undefined) {
                if (isArray) {
                  for (var _j = 0; _j < _node.length; _j++) {
                    var aPath = (0, _ramda.concat)([opath], [_j]);
                    props = (0, _ramda.assocPath)(aPath, handleObject(_node[_j], aPath), props);
                  }
                } else {
                  props = (0, _ramda.assoc)(opath, handleObject(_node, [opath]), props);
                }
              }
            } else {
              var _node2 = props[childrenProp];
              if (_node2 !== undefined) {
                props = (0, _ramda.assoc)(childrenProp, _this4.wrapChildrenProp(_node2, [childrenProp]), props);
              }
            }
          }
        },
        _ret;
      for (var i = 0; i < childrenProps.length; i++) {
        _ret = _loop();
        if (_ret === 0) continue;
      }
      if ((0, _ramda.type)(props.id) === 'Object') {
        // Turn object ids (for wildcards) into unique strings.
        // Because of the `dissoc` above we're not mutating the layout,
        // just the id we pass on to the rendered component
        props.id = (0, _dependencies.stringifyId)(props.id);
      }
      var extraProps = {
        loading_state: loading_state || NOT_LOADING,
        setProps
      };
      return /*#__PURE__*/_react.default.createElement(_ComponentErrorBoundary.default, {
        componentType: _dashprivate_layout.type,
        componentId: props.id,
        key: props.id,
        dispatch: _dashprivate_dispatch,
        error: _dashprivate_error
      }, _dashprivate_config.props_check ? /*#__PURE__*/_react.default.createElement(CheckedComponent, {
        children: children,
        element: element,
        props: props,
        extraProps: extraProps,
        type: _dashprivate_layout.type
      }) : createElement(element, props, extraProps, children));
    }
  }, {
    key: "getLayoutProps",
    value: function getLayoutProps() {
      return (0, _ramda.propOr)({}, 'props', this.props._dashprivate_layout);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        _dashprivate_layout = _this$props3._dashprivate_layout,
        _dashprivate_loadingState = _this$props3._dashprivate_loadingState,
        _dashprivate_path = _this$props3._dashprivate_path;
      var _extraProps = (0, _ramda.omit)(['id', '_dashprivate_error', '_dashprivate_layout', '_dashprivate_loadingState', '_dashprivate_loadingStateHash', '_dashprivate_path', '_dashprivate_config', '_dashprivate_dispatch', '_dashprivate_graphs', '_dashprivate_loadingMap'], this.props);
      var layoutProps = this.getLayoutProps();
      var children = this.getChildren(layoutProps.children, _dashprivate_path);
      return this.getComponent(_dashprivate_layout, children, _dashprivate_loadingState, this.setProps, _extraProps);
    }
  }]);
}(_react.Component);
TreeContainer.propTypes = {
  _dashprivate_error: _propTypes.default.any,
  _dashprivate_layout: _propTypes.default.object,
  _dashprivate_loadingState: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.bool]),
  _dashprivate_loadingStateHash: _propTypes.default.string,
  _dashprivate_path: _propTypes.default.string
};
BaseTreeContainer.propTypes = _objectSpread(_objectSpread({}, TreeContainer.propTypes), {}, {
  _dashprivate_config: _propTypes.default.object,
  _dashprivate_dispatch: _propTypes.default.func,
  _dashprivate_graphs: _propTypes.default.any,
  _dashprivate_loadingMap: _propTypes.default.any,
  _dashprivate_path: _propTypes.default.array
});
var _default = exports.default = TreeContainer;