"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FrontEndError = void 0;
var _reactRedux = require("react-redux");
require("./FrontEndError.css");
var _react = require("react");
var _CollapseIcon = _interopRequireDefault(require("../icons/CollapseIcon.svg"));
var _propTypes = _interopRequireDefault(require("prop-types"));
require("../Percy.css");
var _utils = require("../../../actions/utils");
var _werkzeugcss = _interopRequireDefault(require("../werkzeugcss"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == typeof e || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
var FrontEndError = exports.FrontEndError = /*#__PURE__*/function (_Component) {
  function FrontEndError(props) {
    var _this;
    _classCallCheck(this, FrontEndError);
    _this = _callSuper(this, FrontEndError, [props]);
    _this.state = {
      collapsed: _this.props.isListItem
    };
    return _this;
  }
  _inherits(FrontEndError, _Component);
  return _createClass(FrontEndError, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        e = _this$props.e,
        inAlertsTray = _this$props.inAlertsTray;
      var collapsed = this.state.collapsed;
      var cardClasses = 'dash-error-card__content' + (inAlertsTray ? ' dash-error-card--alerts-tray' : '');

      /* eslint-disable no-inline-comments */
      var errorHeader = /*#__PURE__*/React.createElement("div", {
        className: "dash-fe-error-top test-devtools-error-toggle",
        onClick: function onClick() {
          return _this2.setState({
            collapsed: !collapsed
          });
        }
      }, /*#__PURE__*/React.createElement("span", {
        className: "dash-fe-error-top__group"
      }, "\u26D1\uFE0F", /*#__PURE__*/React.createElement("span", {
        className: "dash-fe-error__title"
      }, e.error.message || 'Error')), /*#__PURE__*/React.createElement("span", {
        className: "dash-fe-error-top__group"
      }, /*#__PURE__*/React.createElement("span", {
        className: "dash-fe-error__timestamp percy-hide"
      }, "".concat(e.timestamp.toLocaleTimeString())), /*#__PURE__*/React.createElement("span", {
        className: "dash-fe-error__timestamp percy-show"
      }, "00:00:00 PM"), /*#__PURE__*/React.createElement(_CollapseIcon.default, {
        className: "dash-fe-error__collapse ".concat(collapsed ? 'dash-fe-error__collapse--flipped' : ''),
        onClick: function onClick() {
          return _this2.setState({
            collapsed: !collapsed
          });
        }
      })));
      /* eslint-enable no-inline-comments */

      return collapsed ? /*#__PURE__*/React.createElement("div", {
        className: "dash-error-card__list-item"
      }, errorHeader) : /*#__PURE__*/React.createElement("div", {
        className: cardClasses
      }, errorHeader, /*#__PURE__*/React.createElement(ErrorContent, {
        error: e.error
      }));
    }
  }]);
}(_react.Component);
var MAX_MESSAGE_LENGTH = 40;
/* eslint-disable no-inline-comments */
function UnconnectedErrorContent(_ref) {
  var error = _ref.error,
    base = _ref.base;
  return /*#__PURE__*/React.createElement("div", {
    className: "error-container"
  }, typeof error.message !== 'string' || error.message.length < MAX_MESSAGE_LENGTH ? null : /*#__PURE__*/React.createElement("div", {
    className: "dash-fe-error__st"
  }, /*#__PURE__*/React.createElement("div", {
    className: "dash-fe-error__info dash-fe-error__curved"
  }, error.message)), typeof error.stack !== 'string' ? null : /*#__PURE__*/React.createElement("div", {
    className: "dash-fe-error__st"
  }, /*#__PURE__*/React.createElement("div", {
    className: "dash-fe-error__info"
  }, /*#__PURE__*/React.createElement("details", null, /*#__PURE__*/React.createElement("summary", null, /*#__PURE__*/React.createElement("i", null, "(This error originated from the built-in JavaScript code that runs Dash apps. Click to see the full stack trace or open your browser's console.)")), error.stack.split('\n').map(function (line, i) {
    return /*#__PURE__*/React.createElement("p", {
      key: i
    }, line);
  })))), typeof error.html !== 'string' ? null : error.html.substring(0, '<!doctype'.length).toLowerCase() === '<!doctype' ? /*#__PURE__*/React.createElement("div", {
    className: "dash-be-error__st"
  }, /*#__PURE__*/React.createElement("div", {
    className: "dash-backend-error"
  }, /*#__PURE__*/React.createElement("iframe", {
    srcDoc: error.html.replace('</head>', "<style type=\"text/css\">".concat(_werkzeugcss.default, "</style></head>")).replace('="?__debugger__', "=\"".concat(base, "?__debugger__")),
    style: {
      /*
       * 67px of padding and margin between this
       * iframe and the parent container.
       * 67 was determined manually in the
       * browser's dev tools.
       */
      width: 'calc(600px - 67px)',
      height: '75vh',
      border: 'none'
    }
  }))) : /*#__PURE__*/React.createElement("div", {
    className: "dash-be-error__str"
  }, /*#__PURE__*/React.createElement("div", {
    className: "dash-backend-error"
  }, error.html)));
}
/* eslint-enable no-inline-comments */

var errorPropTypes = _propTypes.default.shape({
  message: _propTypes.default.string,
  /* front-end error messages */
  stack: _propTypes.default.string,
  /* backend error messages */
  html: _propTypes.default.string
});
UnconnectedErrorContent.propTypes = {
  error: errorPropTypes,
  base: _propTypes.default.string
};
var ErrorContent = (0, _reactRedux.connect)(function (state) {
  return {
    base: (0, _utils.urlBase)(state.config)
  };
})(UnconnectedErrorContent);
FrontEndError.propTypes = {
  e: _propTypes.default.shape({
    timestamp: _propTypes.default.object,
    error: errorPropTypes
  }),
  inAlertsTray: _propTypes.default.bool,
  isListItem: _propTypes.default.bool
};
FrontEndError.defaultProps = {
  inAlertsTray: false,
  isListItem: false
};