"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DebugMenu = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
require("./DebugMenu.css");
var _BellIcon = _interopRequireDefault(require("../icons/BellIcon.svg"));
var _CheckIcon = _interopRequireDefault(require("../icons/CheckIcon.svg"));
var _ClockIcon = _interopRequireDefault(require("../icons/ClockIcon.svg"));
var _DebugIcon = _interopRequireDefault(require("../icons/DebugIcon.svg"));
var _GraphIcon = _interopRequireDefault(require("../icons/GraphIcon.svg"));
var _OffIcon = _interopRequireDefault(require("../icons/OffIcon.svg"));
var _GlobalErrorOverlay = _interopRequireDefault(require("../GlobalErrorOverlay.react"));
var _CallbackGraphContainer = require("../CallbackGraph/CallbackGraphContainer.react");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == typeof e || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
var classes = function classes(base, variant, variant2) {
  return "".concat(base, " ").concat(base, "--").concat(variant) + (variant2 ? " ".concat(base, "--").concat(variant2) : '');
};
var buttonFactory = function buttonFactory(enabled, buttonVariant, toggle, _Icon, iconVariant, label) {
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "dash-debug-menu__button-container"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: classes('dash-debug-menu__button', buttonVariant, enabled && 'enabled'),
    onClick: toggle
  }, /*#__PURE__*/_react.default.createElement(_Icon, {
    className: classes('dash-debug-menu__icon', iconVariant)
  }), label ? /*#__PURE__*/_react.default.createElement("label", {
    className: "dash-debug-menu__button-label"
  }, label) : null));
};
var DebugMenu = exports.DebugMenu = /*#__PURE__*/function (_Component) {
  function DebugMenu(props) {
    var _this;
    _classCallCheck(this, DebugMenu);
    _this = _callSuper(this, DebugMenu, [props]);
    _this.state = {
      opened: false,
      callbackGraphOpened: false,
      errorsOpened: true
    };
    return _this;
  }
  _inherits(DebugMenu, _Component);
  return _createClass(DebugMenu, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$state = this.state,
        opened = _this$state.opened,
        errorsOpened = _this$state.errorsOpened,
        callbackGraphOpened = _this$state.callbackGraphOpened;
      var _this$props = this.props,
        error = _this$props.error,
        hotReload = _this$props.hotReload;
      var errCount = error.frontEnd.length + error.backEnd.length;
      var connected = error.backEndConnected;
      var toggleErrors = function toggleErrors() {
        _this2.setState({
          errorsOpened: !errorsOpened
        });
      };
      var status = hotReload ? connected ? 'available' : 'unavailable' : 'cold';
      var _StatusIcon = hotReload ? connected ? _CheckIcon.default : _OffIcon.default : _ClockIcon.default;
      var menuContent = opened ? /*#__PURE__*/_react.default.createElement("div", {
        className: "dash-debug-menu__content"
      }, callbackGraphOpened ? /*#__PURE__*/_react.default.createElement(_CallbackGraphContainer.CallbackGraphContainer, null) : null, buttonFactory(callbackGraphOpened, 'callbacks', function () {
        _this2.setState({
          callbackGraphOpened: !callbackGraphOpened
        });
      }, _GraphIcon.default, 'graph', 'Callbacks'), buttonFactory(errorsOpened, 'errors', toggleErrors, _BellIcon.default, 'bell', errCount + ' Error' + (errCount === 1 ? '' : 's')), buttonFactory(false, status, null, _StatusIcon, 'indicator', 'Server')) : /*#__PURE__*/_react.default.createElement("div", {
        className: "dash-debug-menu__content"
      });
      var alertsLabel = (errCount || !connected) && !opened ? /*#__PURE__*/_react.default.createElement("div", {
        className: "dash-debug-alert-label"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "dash-debug-alert",
        onClick: toggleErrors
      }, errCount ? /*#__PURE__*/_react.default.createElement("div", {
        className: "dash-debug-error-count"
      }, '🛑 ' + errCount) : null, connected ? null : /*#__PURE__*/_react.default.createElement("div", {
        className: "dash-debug-disconnected"
      }, "\uD83D\uDEAB"))) : null;
      var openVariant = opened ? 'open' : 'closed';
      return /*#__PURE__*/_react.default.createElement("div", null, alertsLabel, /*#__PURE__*/_react.default.createElement("div", {
        className: classes('dash-debug-menu__outer', openVariant)
      }, menuContent), /*#__PURE__*/_react.default.createElement("div", {
        className: classes('dash-debug-menu', openVariant),
        onClick: function onClick() {
          _this2.setState({
            opened: !opened
          });
        }
      }, /*#__PURE__*/_react.default.createElement(_DebugIcon.default, {
        className: classes('dash-debug-menu__icon', 'debug')
      })), /*#__PURE__*/_react.default.createElement(_GlobalErrorOverlay.default, {
        error: error,
        visible: errCount > 0,
        errorsOpened: errorsOpened,
        clickHandler: toggleErrors
      }, this.props.children));
    }
  }]);
}(_react.Component);
DebugMenu.propTypes = {
  children: _propTypes.default.object,
  error: _propTypes.default.object,
  hotReload: _propTypes.default.bool
};