"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _ramda = require("ramda");
var _loadingMap = require("../actions/loadingMap");
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
var observer = {
  observer: function observer(_ref) {
    var dispatch = _ref.dispatch,
      getState = _ref.getState;
    var _getState = getState(),
      _getState$callbacks = _getState.callbacks,
      executing = _getState$callbacks.executing,
      watched = _getState$callbacks.watched,
      executed = _getState$callbacks.executed,
      loadingMap = _getState.loadingMap,
      paths = _getState.paths;

    /*
        Get the path of all components impacted by callbacks
        with states: executing, watched, executed.
         For each path, keep track of all (id,prop) tuples that
        are impacted for this node and nested nodes.
    */

    var loadingPaths = (0, _ramda.flatten)((0, _ramda.map)(function (cb) {
      return cb.getOutputs(paths);
    }, [].concat(_toConsumableArray(executing), _toConsumableArray(watched), _toConsumableArray(executed))));
    var nextMap = (0, _ramda.isEmpty)(loadingPaths) ? null : (0, _ramda.reduce)(function (res, _ref2) {
      var id = _ref2.id,
        property = _ref2.property,
        path = _ref2.path;
      var target = res;
      var idprop = {
        id,
        property
      };

      // Assign all affected props for this path and nested paths
      target.__dashprivate__idprops__ = target.__dashprivate__idprops__ || [];
      target.__dashprivate__idprops__.push(idprop);
      path.forEach(function (p, i) {
        var _target$p;
        target = target[p] = (_target$p = target[p]) !== null && _target$p !== void 0 ? _target$p : p === 'children' && typeof path[i + 1] === 'number' ? [] : {};
        target.__dashprivate__idprops__ = target.__dashprivate__idprops__ || [];
        target.__dashprivate__idprops__.push(idprop);
      });

      // Assign one affected prop for this path
      target.__dashprivate__idprop__ = target.__dashprivate__idprop__ || idprop;
      return res;
    }, {}, loadingPaths);
    if (!(0, _ramda.equals)(nextMap, loadingMap)) {
      dispatch((0, _loadingMap.setLoadingMap)(nextMap));
    }
  },
  inputs: ['callbacks.executing', 'callbacks.watched', 'callbacks.executed']
};
var _default = exports.default = observer;